#!/bin/sh
set -e

SCRIPT_DIR=$(realpath `dirname "$0"`)


. $SCRIPT_DIR/download_boot_systems.sh

download_debian_10_if_needed
download_sysrescuecd_if_needed

#UPDATE THOSE VARIABLES DEPENDING ON YOUR SITE
MY_IF_NAME=VLAN100
MY_IP_ADDR=124.219.111.33
DHCP_RANGE=124.219.111.33,static,255.255.255.224
ROUTER_ADDR=124.219.111.62
DNS_SERVER=8.8.8.8

common=console=ttyS0,57600

mac='
98:03:9b:9b:8a:47
b8:59:9f:37:9a:bd
b8:59:9f:37:9a:c5
b8:59:9f:37:9a:9d
b8:59:9f:36:2b:e3
b8:59:9f:37:9f:cd
b8:59:9f:37:9f:9d
b8:59:9f:37:9b:8d
b8:59:9f:35:68:07
b8:59:9f:35:5f:67
98:03:9b:9a:e5:8b
b8:59:9f:37:a3:a5
b8:59:9f:37:9a:b5
98:03:9b:9c:22:89
'
i=1
hostname_prefix=hsinchu-tiogapass-

(
#echo set timeout=0
echo if false
echo then true
for mac in $mac; do
  echo "elif [ \$net_default_mac = $mac ]"
  echo then set i=`printf %03u $i`
  i=`expr $i + 1`
done
cat <<EOF
else unset timeout
fi

menuentry 'Install Debian' {
  linux /debian-installer/amd64/linux vga=788 url=tftp://\$pxe_default_server/preseed_hsinchu.cfg language=C country=CN keymap=us hostname=${hostname_prefix}\$i domain= --- mitigations=off $common
  initrd /debian-installer/amd64/initrd.gz
}
menuentry 'SystemRescueCd' {
  linux /sysresccd/sysresccd/boot/x86_64/vmlinuz archisobasedir=sysresccd archiso_http_srv=http://\$pxe_default_server:69/sysresccd/ checksum ip=dhcp $common
  initrd /sysresccd/sysresccd/boot/intel_ucode.img /sysresccd/sysresccd/boot/amd_ucode.img /sysresccd/sysresccd/boot/x86_64/sysresccd.img
}
menuentry 'Exit' {
  exit
}
EOF
) >debian-installer/amd64/grub/grub.cfg


for mac in $mac
do
  hostname=${hostname_prefix}$(printf %03u $i)
  mkdir -p $hostname
  cat > $hostname/interfaces <<EOF
# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

source /etc/network/interfaces.d/*

# The loopback network interface
auto lo
iface lo inet loopback

# The primary network interface
allow-hotplug eno1
#iface eno1 inet dhcp
iface eno1 inet static
  address 192.168.46.$(( 50 + $i ))/24

allow-hotplug ens9f1
iface ens9f1 inet static
  address 124.219.111.$((33 + $i ))/27
  gateway 124.219.111.62
  dns-nameservers 8.8.8.8 8.8.4.4
EOF
  i=`expr $i + 1`
done




exec dnsmasq -d --port=0 --log-dhcp \
  --interface=$MY_IF_NAME \
  --bind-interfaces \
  --except-interface=lo \
  --listen-address=$MY_IP_ADDR \
  --dhcp-range=$DHCP_RANGE \
  --dhcp-option=option:router,$ROUTER_ADDR \
  --dhcp-option=option:dns-server,$DNS_SERVER \
  --dhcp-boot=debian-installer/amd64/grubx64.efi \
  --enable-tftp --tftp-root=$(realpath `dirname "$0"`) \
  --conf-file=/dev/null \
  --dhcp-host=98:03:9b:9b:8a:47,124.219.111.34,1h \
  --dhcp-host=b8:59:9f:37:9a:bd,124.219.111.35,1h \
  --dhcp-host=b8:59:9f:37:9a:c5,124.219.111.36,1h \
  --dhcp-host=b8:59:9f:37:9a:9d,124.219.111.37,1h \
  --dhcp-host=b8:59:9f:36:2b:e3,124.219.111.38,1h \
  --dhcp-host=b8:59:9f:37:9f:cd,124.219.111.39,1h \
  --dhcp-host=b8:59:9f:37:9f:9d,124.219.111.40,1h \
  --dhcp-host=b8:59:9f:37:9b:8d,124.219.111.41,1h \
  --dhcp-host=b8:59:9f:35:68:07,124.219.111.42,1h \
  --dhcp-host=b8:59:9f:35:5f:67,124.219.111.43,1h \
  --dhcp-host=98:03:9b:9a:e5:8b,124.219.111.44,1h \
  --dhcp-host=b8:59:9f:37:a3:a5,124.219.111.45,1h \
  --dhcp-host=b8:59:9f:37:9a:b5,124.219.111.46,1h \
  --dhcp-host=98:03:9b:9c:22:89,124.219.111.47,1h

