#!/bin/sh
set -e

SCRIPT_DIR=$(realpath `dirname "$0"`)


. $SCRIPT_DIR/download_boot_systems.sh

download_debian_10_if_needed
download_sysrescuecd_if_needed

#UPDATE THOSE VARIABLES DEPENDING ON YOUR SITE
MY_IF_NAME=VLAN100
MY_IP_ADDR=10.0.45.1
DHCP_RANGE=10.0.45.100,static,255.255.255.0
ROUTER_ADDR=10.0.45.1
DNS_SERVER=1.2.4.8

common=console=ttyS1,57600

(mac='
f4:52:14:fc:a4:94
f4:52:14:f9:0c:2a
e4:1d:2d:52:ea:e4
f4:52:14:fc:3e:58
f4:52:14:a7:12:c4
f4:52:14:a8:8b:34
f4:52:14:a5:f5:8c
f4:52:14:f3:c9:cc
f4:52:14:f8:c8:e0
f4:52:14:fc:5f:ac
f4:52:14:b0:91:2c
f4:52:14:f8:86:ec
e4:1d:2d:52:40:d4
f4:52:14:fc:5b:ce
e4:1d:2d:52:5c:64
e4:1d:2d:52:c7:ce
f4:52:14:b0:60:84
f4:52:14:f8:e9:b6
f4:52:14:fa:1a:06
f4:52:14:fc:b6:5e
f4:52:14:a6:f3:e4
f4:52:14:a8:23:7e
f4:52:14:f8:a9:60
f4:52:14:a6:8b:98
e4:1d:2d:52:f3:1e
f4:52:14:fc:40:e0
e4:1d:2d:52:7f:f8
e4:1d:2d:52:cd:14
f4:52:14:f8:d5:d0
f4:52:14:fd:01:74
f4:52:14:fc:53:b8
e4:1d:2d:52:c1:7a
e4:1d:2d:52:f7:32
f4:52:14:f3:d5:d2
f4:52:14:fa:37:e8
e4:1d:2d:52:29:6a
'
i=0
hostname_prefix=hydro66-leopard

(
#echo set timeout=0
echo if false
echo then true
for mac in $mac; do
  echo "elif [ \$net_default_mac = $mac ]"
  echo then set i=`printf %03u $i`
  i=`expr $i + 1`
done
cat <<EOF
else unset timeout
fi

menuentry 'Install Debian' {
  linux /debian-installer/amd64/linux vga=788 url=tftp://\$pxe_default_server/preseed_hydro66.cfg language=C country=SE keymap=us hostname=${hostname_prefix}\$i domain= --- mitigations=off $common
  initrd /debian-installer/amd64/initrd.gz
}
menuentry 'SystemRescueCd' {
  linux /sysresccd/sysresccd/boot/x86_64/vmlinuz archisobasedir=sysresccd archiso_http_srv=http://\$pxe_default_server:69/sysresccd/ checksum ip=dhcp $common
  initrd /sysresccd/sysresccd/boot/intel_ucode.img /sysresccd/sysresccd/boot/amd_ucode.img /sysresccd/sysresccd/boot/x86_64/sysresccd.img
}
menuentry 'Exit' {
  exit
}
EOF
) >debian-installer/amd64/grub/grub.cfg


for mac in $mac
do
  hostname=${hostname_prefix}$(printf %03u $i)
  mkdir -p $hostname
  cat > $hostname/interfaces <<EOF
# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

source /etc/network/interfaces.d/*

# The loopback network interface
auto lo
iface lo inet loopback

# The primary network interface
allow-hotplug eno1
#iface eno1 inet dhcp
iface eno1 inet static
  address 192.168.46.$(( 50 + $i ))/24

allow-hotplug ens9f1
iface ens9f1 inet static
  address 10.0.45.$(( 50 + $i ))/24
  gateway 10.0.45.1
  dns-nameservers 1.2.4.8 223.5.5.5 223.6.6.6

#allow-hotplug ens9f0
##iface ens9f0 inet dhcp
#iface ens9f0 inet static
#  address 113.24.192.26/30
#  gateway 113.24.192.25
EOF
  i=`expr $i + 1`
done




exec dnsmasq -d --port=0 --log-dhcp \
  --interface=$MY_IF_NAME \
  --bind-interfaces \
  --except-interface=lo \
  --listen-address=$MY_IP_ADDR \
  --dhcp-range=$DHCP_RANGE \
  --dhcp-option=option:router,$ROUTER_ADDR \
  --dhcp-option=option:dns-server,$DNS_SERVER \
  --dhcp-boot=debian-installer/amd64/grubx64.efi \
  --enable-tftp --tftp-root=$(realpath `dirname "$0"`) \
  --conf-file=/dev/null \
  --dhcp-host=98:03:9b:9b:8a:47,10.0.45.101,1h

